# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#
#    Copyright (c) 2010 moylop260 - http://moylop.blogspot.com/
#    All Rights Reserved.
#    info moylop260 (moylop260@vauxoo.com)
############################################################################
############################################################################
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv
from osv import fields
import time

class account_invoice(osv.osv):
    _inherit = 'account.invoice'
    
    def button_reset_taxes(self, cr, uid, ids, context=None):
        invoice_line_obj = self.pool.get('account.invoice.line')
        #res_users_obj = self.pool.get('res.users')
        new_invoice_value = {}
        for invoice in self.browse(cr, uid, ids, context=context):
            company_id = invoice.journal_id.company_id.id
            new_invoice_value['company_id'] = company_id
            #res_users_obj.write(cr, uid, [uid], {'company_id': new_invoice_value['company_id']} )
            partner_value = self.onchange_partner_id(cr, uid, ids, type=invoice.type, partner_id=invoice.partner_id.id, date_invoice=invoice.date_invoice, payment_term=invoice.payment_term and invoice.payment_term.id or False, partner_bank_id=invoice.partner_bank_id and invoice.partner_bank_id.id or False, company_id=company_id )['value']
            account_id = partner_value.get('account_id', False)
            if account_id:
                new_invoice_value['account_id'] = account_id
            self.write(cr, uid, [invoice.id], new_invoice_value)
            line_ids = [line.id for line in invoice.invoice_line]
            invoice_line_obj.write(cr, uid, line_ids, {'company_id': company_id })
            for invoice_line in invoice_line_obj.browse(cr, uid, line_ids, context={'company_id': company_id, 'force_company': company_id}):
                line_value = invoice_line_obj.product_id_change(cr, uid, [], invoice_line.product_id and invoice_line.product_id.id or False, invoice_line.uos_id and invoice_line.uos_id.id or False, invoice_line.quantity, invoice_line.name, invoice_line.invoice_id.type, invoice_line.invoice_id.partner_id.id, invoice_line.invoice_id.fiscal_position and invoice_line.invoice_id.fiscal_position.id or False, invoice_line.price_unit, invoice_line.invoice_id.address_invoice_id.id, invoice_line.invoice_id.currency_id.id, context={'company_id': new_invoice_value['company_id'], 'force_company': new_invoice_value['company_id']})['value']
                tax_ids = line_value.get('invoice_line_tax_id', [])
                """
                #product_id = invoice_line.product_id and invoice_line.product_id.id or False
                #if product_id:
                    #res = self.pool.get('product.product').browse(cr, uid, product_id, context=context)
                
                    in_pro_id = self.pool.get('ir.property').search(cr,uid,[('name','=','property_account_income'),('res_id','=','product.template,'+str(res.product_tmpl_id.id)+''),('company_id','=',company_id)])
                    print "cr.query",cr.query
                    print "in_pro_id",in_pro_id
                    if not in_pro_id:
                        in_pro_id = self.pool.get('ir.property').search(cr,uid,[('name','=','property_account_income_categ'),('res_id','=','product.template,'+str(res.categ_id.id)+''),('company_id','=',company_id)])
                    print "cr.query",cr.query
                    print "in_pro_id",in_pro_id
                    print "aqui"
                    exp_pro_id = self.pool.get('ir.property').search(cr,uid,[('name','=','property_account_expense'),('res_id','=','product.template,'+str(res.product_tmpl_id.id)+''),('company_id','=',company_id)])
                    if not exp_pro_id:
                        exp_pro_id = self.pool.get('ir.property').search(cr,uid,[('name','=','property_account_expense_categ'),('res_id','=','product.template,'+str(res.categ_id.id)+''),('company_id','=',company_id)])
                """
                new_line_value = {
                    'account_id': line_value.get('account_id', False),
                    #'account_id': in_pro_id and in_pro_id [0],#este valor si es factura de venta
                    #'invoice_line_tax_id': [],#(0, 0, line_value.get('invoice_line_tax_id', False)) ],
                    'name': time.strftime('%Y-%m-%d %H:%M:%S'),
                    #property_account_income_categ
                    #property_account_income
                    'invoice_line_tax_id': [(6,0, tax_ids) ],
                }
                res = invoice_line_obj.write(cr, uid, [invoice_line.id], new_line_value)
                
        return super(account_invoice, self).button_reset_taxes(cr, uid, ids, context=context)
    
    """
    def onchange_journal_id(self, cr, uid, ids, journal_id=False):
        invoice_line_obj = self.pool.get('account.invoice.line')
        result = super(account_invoice, self).onchange_journal_id(cr, uid, ids, journal_id=journal_id)
        result_value = result.setdefault('value', {})
        if journal_id:
            journal = self.pool.get('account.journal').browse(cr, uid, journal_id)
            result_value.update({
                'company_id': journal.company_id.id
            })
            if ids:
                invoice = self.browse(cr, uid, ids[0])
                partner_value = self.onchange_partner_id(cr, uid, ids, type=invoice.type, partner_id=invoice.partner_id.id, date_invoice=invoice.date_invoice, payment_term=invoice.payment_term and invoice.payment_term.id or False, partner_bank_id=invoice.partner_bank_id and invoice.partner_bank_id.id or False, company_id=journal.company_id.id)['value']
                account_id = partner_value.get('account_id', False)
                if account_id:
                    result_value.update( {'account_id': account_id} )
                for invoice_line in invoice.invoice_line:
                    line_value = invoice_line_obj.product_id_change(cr, uid, [], invoice_line.product_id and invoice_line.product_id.id or False, invoice_line.uos_id and invoice_line.uos_id.id or False, invoice_line.quantity, invoice_line.name, invoice_line.invoice_id.type, invoice_line.invoice_id.partner_id.id, invoice_line.invoice_id.fiscal_position and invoice_line.invoice_id.fiscal_position.id or False, invoice_line.price_unit, invoice_line.invoice_id.address_invoice_id.id, invoice_line.invoice_id.currency_id.id, context={'company_id': invoice_line.invoice_id.company_id.id})['value']
                    new_line_value = {
                        'account_id': line_value.get('account_id', False),
                        'invoice_line_tax_id': line_value.get('invoice_line_tax_id', False),
                    }
                    res = invoice_line_obj.write(cr, uid, [invoice_line.id], new_line_value)
                    
        return result
    """
account_invoice()

"""
    def product_id_change(self, cr, uid, ids, product, uom, qty=0, name='', type='out_invoice', partner_id=False, fposition_id=False, price_unit=False, address_invoice_id=False, context=None):
        company_id = context.get('company_id',False)
        if not partner_id:
            raise osv.except_osv(_('No Partner Defined !'),_("You must first select a partner !") )
        if not product:
            if type in ('in_invoice', 'in_refund'):
                return {'value': {'categ_id': False}, 'domain':{'product_uom':[]}}
            else:
                return {'value': {'price_unit': 0.0, 'categ_id': False}, 'domain':{'product_uom':[]}}
        part = self.pool.get('res.partner').browse(cr, uid, partner_id)
        fpos = fposition_id and self.pool.get('account.fiscal.position').browse(cr, uid, fposition_id) or False

        lang=part.lang
        context.update({'lang': lang})
        result = {}
        res = self.pool.get('product.product').browse(cr, uid, product, context=context)
        if company_id:
            in_pro_id = self.pool.get('ir.property').search(cr,uid,[('name','=','property_account_income'),('res_id','=','product.template,'+str(res.product_tmpl_id.id)+''),('company_id','=',company_id)])
            if not in_pro_id:
                in_pro_id = self.pool.get('ir.property').search(cr,uid,[('name','=','property_account_income_categ'),('res_id','=','product.template,'+str(res.categ_id.id)+''),('company_id','=',company_id)])
            exp_pro_id = self.pool.get('ir.property').search(cr,uid,[('name','=','property_account_expense'),('res_id','=','product.template,'+str(res.product_tmpl_id.id)+''),('company_id','=',company_id)])
            if not exp_pro_id:
                exp_pro_id = self.pool.get('ir.property').search(cr,uid,[('name','=','property_account_expense_categ'),('res_id','=','product.template,'+str(res.categ_id.id)+''),('company_id','=',company_id)])
            
            if not in_pro_id:
                in_acc = res.product_tmpl_id.property_account_income 
                in_acc_cate = res.categ_id.property_account_income_categ
                if in_acc:
                    app_acc_in = in_acc
                else:
                    app_acc_in = in_acc_cate
            else:
                app_acc_in = self.pool.get('account.account').browse(cr,uid,in_pro_id)[0]
            if not exp_pro_id:
                ex_acc = res.product_tmpl_id.property_account_expense
                ex_acc_cate = res.categ_id.property_account_expense_categ
                if ex_acc:
                    app_acc_exp = ex_acc
                else:
                    app_acc_exp = ex_acc_cate
            else:
                app_acc_exp = self.pool.get('account.account').browse(cr,uid,exp_pro_id)[0]
            if not in_pro_id and not exp_pro_id:
                in_acc = res.product_tmpl_id.property_account_income 
                in_acc_cate = res.categ_id.property_account_income_categ
                ex_acc = res.product_tmpl_id.property_account_expense
                ex_acc_cate = res.categ_id.property_account_expense_categ
                if in_acc or ex_acc:
                    app_acc_in = in_acc
                    app_acc_exp = ex_acc
                else:
                    app_acc_in = in_acc_cate
                    app_acc_exp = ex_acc_cate
#            else:
#                app_acc_in = self.pool.get('account.account').browse(cr,uid,in_pro_id)[0]
#                app_acc_exp = self.pool.get('account.account').browse(cr,uid,exp_pro_id)[0]
            if app_acc_in.company_id.id != company_id and app_acc_exp.company_id.id != company_id:
                in_res_id=self.pool.get('account.account').search(cr,uid,[('name','=',app_acc_in.name),('company_id','=',company_id)])
                exp_res_id=self.pool.get('account.account').search(cr,uid,[('name','=',app_acc_exp.name),('company_id','=',company_id)])
                if not in_res_id and not exp_res_id:
                    raise osv.except_osv(_('Configration Error !'),
                        _('Can not find account chart for this company, Please Create account.'))
                in_obj_acc=self.pool.get('account.account').browse(cr,uid,in_res_id)
                exp_obj_acc=self.pool.get('account.account').browse(cr,uid,exp_res_id)
                if in_acc or ex_acc:
                    res.product_tmpl_id.property_account_income = in_obj_acc[0]
                    res.product_tmpl_id.property_account_expense = exp_obj_acc[0]
                else:
                    res.categ_id.property_account_income_categ = in_obj_acc[0]
                    res.categ_id.property_account_expense_categ = exp_obj_acc[0]

        if type in ('out_invoice','out_refund'):
            a =  res.product_tmpl_id.property_account_income.id
            if not a:
                a = res.categ_id.property_account_income_categ.id
        else:
            a =  res.product_tmpl_id.property_account_expense.id
            if not a:
                a = res.categ_id.property_account_expense_categ.id

        a = self.pool.get('account.fiscal.position').map_account(cr, uid, fpos, a)
        if a:
            result['account_id'] = a

        taxep=None
        tax_obj = self.pool.get('account.tax')
        if type in ('out_invoice', 'out_refund'):
            taxes = res.taxes_id and res.taxes_id or (a and self.pool.get('account.account').browse(cr, uid,a).tax_ids or False)
            tax_id = self.pool.get('account.fiscal.position').map_tax(cr, uid, fpos, taxes)
        else:
            taxes = res.supplier_taxes_id and res.supplier_taxes_id or (a and self.pool.get('account.account').browse(cr, uid,a).tax_ids or False)
            tax_id = self.pool.get('account.fiscal.position').map_tax(cr, uid, fpos, taxes)
        if type in ('in_invoice', 'in_refund'):
            to_update = self.product_id_change_unit_price_inv(cr, uid, tax_id, price_unit, qty, address_invoice_id, product, partner_id, context=context)
            result.update(to_update)
        else:
            result.update({'price_unit': res.list_price, 'invoice_line_tax_id': tax_id})

        if not name:
            result['name'] = res.name

        domain = {}
        result['uos_id'] = uom or res.uom_id.id or False
        if result['uos_id']:
            res2 = res.uom_id.category_id.id
            if res2 :
                domain = {'uos_id':[('category_id','=',res2 )]}

        prod_pool=self.pool.get('product.product')            
        result['categ_id'] = res.categ_id.id       
        return {'value':result, 'domain':domain}

"""
