# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#
#    Copyright (c) 2010 moylop260 - http://moylop.blogspot.com/
#    All Rights Reserved.
#    info moylop260 (moylop260@hotmail.com)
############################################################################
#    Coded by: Fernando Irene Garcia (fernandoig1125@hotmail.com)
############################################################################
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from report import report_sxw
import pooler
import tools
from amount_to_text_es import amount_to_text as amount_to_text_class

amount_to_text_obj = amount_to_text_class()
amount_to_text = amount_to_text_obj.amount_to_text_cheque

class invoice_calzado_tracy(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(invoice_calzado_tracy, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'amount_to_text': self._get_amount_to_text,
            'get_fecha': self._get_fecha,
            'get_columns':self._get_columns,
        })
    def _get_fecha(self, invoice):
        valores = []
        res = {}
        fecha = invoice.date_invoice
        ano = fecha[0:4]
        mes = fecha[5:7]
        dia = fecha[8:]
        meses = {'01':'Enero','02':'Febrero','03':'Marzo','04':'Abril','05':'Mayo','06':'Junio',
                 '07':'Julio','08':'Agosto','09':'Septiembre','10':'Octubre','11':'Noviembre',
                 '12':'Diciembre'}
        for m in meses:
            if mes == m:
                res['mes']=meses[m]
        res['dia']=dia
        res['ano']=ano
        valores.append(res)
        return valores
    def _get_amount_to_text(self, amount, lang, currency=""):
        if currency.upper() in ('MXP', 'MXN', 'PESOS', 'PESOS MEXICANOS'):
            sufijo = 'M. N.'
            currency = 'PESOS'
        else:
            sufijo = 'M. E.'
        amount_text = amount_to_text(amount, currency, sufijo)
        amount_text = amount_text and amount_text.upper() or ''
        return amount_text
    def _get_columns(self, invoice, descripcion):
        valores=[]
        des = descripcion[0][0]
        invoice_line_obj = self.pool.get('account.invoice.line')
        invoice_lines_ids = invoice_line_obj.search(self.cr, self.uid, [('invoice_id','=',invoice.id)])
        ids = invoice_line_obj.browse(self.cr, self.uid, invoice_lines_ids)
        for i in ids:
            res={}
            description = i.name
            valores.append(description)
        length = len(valores)
        index_des = valores.index(des)
        if index_des != (length-1):
            datos=[]
            for d in range(0, len(des), 38):
                if len(des) > 38:
                    lista = des[:38]
                    if lista:
                        datos.append(lista)
                        des = des.replace(lista,'')
                else:
                    lista = des
                    datos.append(lista)
            return datos
        else:
            datos = []
            datos2= []
            valor='-'
            for v in valores:
                index_des = valores.index(v)
                des = v
                if index_des != (length-1):
                    for d in range(0, len(des), 38):
                        if len(des) > 38:
                            lista = des[:38]
                            if lista:
                                datos2.append(lista)
                                des = des.replace(lista,'')
                        else:
                            lista = des
                            datos2.append(lista)
                else:
                    for d in range(0, len(des), 38):
                        if len(des) > 38:
                            lista = des[:38]
                            if lista:
                                datos.append(lista)
                                des = des.replace(lista,'')
                        else:
                            lista = des
                            datos.append(lista)
            resto = 14-(len(datos)+len(datos2))
            for r in range(0, resto):
                datos.append(valor)
            return datos
report_sxw.report_sxw(
    'report.invoice.calzado.tracy',
    'account.invoice',
    'addons/account_invoicereport_nono9/report/invoice_calzado_tracy.rml',
    header=False,
    parser=invoice_calzado_tracy,
)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

