# -*- coding: utf-8 -*-
from osv import osv, fields
import netsvc
import time
from tools.translate import _

class wizard_finished_wcl(osv.osv_memory):
    _name = 'wizard.finished.wcl'
    _description = 'Finish a Work Center Line with a sequence'

    _columns = {
        'productions_ids': fields.many2many('mrp.production', 'mrp_prod_wizard_finish_rel', 'wizar_id', 'production_ids', 'Produccion', required=True, domain="[('state', '<>', 'cancel')]" ),
        'workcenter_line_id': fields.many2one('mrp.production.workcenter.line', 'Fraccion', required=True),
        'employee_id': fields.many2one('hr.employee', 'Empleado', required=True),
        'rink_id': fields.many2one('mrp.production.workcenter.rink', 'Rink', required=True),##Falta el RINK
        #'workcenter_id': fields.many2one('mrp.workcenter', 'Departamento', required=False),
        'sequence': fields.integer('Fraccion', required=False),
    }

    def write_data(self, cr, uid, ids, context={}):
        if context is None:
            context = {}
        data = self.read(cr, uid, ids)[0]
        wkl_obj = self.pool.get('mrp.production.workcenter.line')

    def confirm(self, cr, uid, ids, context={}):
        if context is None:
            context = {}
        wkl_obj = self.pool.get('mrp.production.workcenter.line')
        wf_service = netsvc.LocalService("workflow")
        data = self.read(cr, uid, ids)[0]

        #~ workcenter_line_id = data['workcenter_line_id']


        lista_enviar=wkl_obj.search(cr, uid, [
            ('production_id', 'in',data['productions_ids']),
            ('sequence', '=', data['sequence']),
            ('state', '<>', 'done'),
            #~ ('name','ilike','%pase%'),
        ], order='production_id, sequence', context=context)
        if not lista_enviar:
            raise osv.except_osv(_('UserError!'),_('La secuencia ingresada no existe. Ingrese un secuencia existente'))

        for workcenter_line_id in lista_enviar:
        #------------- esta es la parte que se debe modifcar para que tome con varios ids
            workcenter_line_ids_prev = wkl_obj.get_previous(cr, uid, [workcenter_line_id], context=context)

            wf_service.trg_validate(uid, 'mrp.production.workcenter.line', workcenter_line_id, 'button_start_working', cr)
            wf_service.trg_validate(uid, 'mrp.production.workcenter.line', workcenter_line_id, 'button_done', cr)
            state = wkl_obj.read(cr, uid, [workcenter_line_id], ['state'], context=context)[0]['state']
            if state <> 'done':
                raise osv.except_osv(_('UserError'), _('No se pudo finalizar esta fraccion\nSe quedo en estado [%s]'%(state)))
            #workcenter_line_ids_prev.append( workcenter_line_id )
            wkl_obj.write(cr, uid, workcenter_line_ids_prev + [workcenter_line_id], {'employee_id': data['employee_id'], 'rink_id': data['rink_id']} )
            #---------------------------------

        return {}


    def onchange_productions_ids(self, cr, uid, ids, productions_ids, context={}):
        production_obj = self.pool.get('mrp.production')
        wkl_obj = self.pool.get('mrp.production.workcenter.line')
        res = {}

        wkl_ids = wkl_obj.search(cr, uid, [
            ('production_id', 'in', productions_ids[0][2]),
            ('state', '<>', 'done'),
            ('name','ilike','%pase%'),
        ], limit=1, order='production_id, sequence', context=context)
        wkl_id = wkl_ids and wkl_ids[0] or False
        res['value'] = {'workcenter_line_id': wkl_id}
        return res

    #~ def onchange_production_id(self, cr, uid, ids, production_id, context={}):
        #~ print 'los ids de production_id son ',production_id
        #~ production_obj = self.pool.get('mrp.production')
        #~ wkl_obj = self.pool.get('mrp.production.workcenter.line')
        #~ res = {}
        #~ wkl_ids = wkl_obj.search(cr, uid, [
            #~ ('production_id', '=', production_id),
            #~ ('state', '<>', 'done'),
            #~ ('name','ilike','%pase%'),
        #~ ], limit=1, order='production_id, sequence', context=context)
        #~ wkl_id = wkl_ids and wkl_ids[0] or False
        #~ res['value'] = {'workcenter_line_id': wkl_id}
        #~ return res

wizard_finished_wcl()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

