# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#
#    Copyright (c) 2010 moylop260 - http://moylop.blogspot.com/
#    All Rights Reserved.
#    info moylop260 (moylop260@hotmail.com)
############################################################################
#    Coded by: moylop260 (moylop260@hotmail.com)
############################################################################
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
import netsvc
import time

class sale_order_line(osv.osv):
    _inherit = 'sale.order.line'
    
    _columns = {
        'date_planned_start': fields.datetime(u'Date Planned Start'),
        'product_qty_split': fields.integer(u'Quantity Split Lot'),
    }
sale_order_line()

class sale_order(osv.osv):
    _inherit = "sale.order"
    
    def _production_rate(self, cursor, user, ids, name, arg, context=None):
        res = {}
        production_obj = self.pool.get('mrp.production')
        for sale in self.browse(cursor, user, ids, context=context):
            production_ids = production_obj.search(cursor, user, [('sale_id', '=', sale.id)], context=context)
            #print "sale_id",sale.id
            #print "production_ids",production_ids
            productions = production_obj.browse(cursor, user, production_ids, context=context)
            #print "production_ids",production_ids
            if sale.produced:
                res[sale.id] = 100.0
                continue
            tot = 0.0
            for production in productions:
                if production.state not in ('draft', 'cancel'):
                    tot += production.product_qty
            if tot:
                sale_total_qty = sum([sale_line.product_uom_qty for sale_line in sale.order_line])
                #print "sale_total_qty",sale_total_qty
                #print "tot",tot
                res[sale.id] = min(100.0, tot * 100.0 / sale_total_qty or 1.00)
            else:
                res[sale.id] = 0.0
            #print "********************"
        return res
    
    def _produced(self, cursor, user, ids, name, arg, context=None):
        res = {}
        for sale in self.browse(cursor, user, ids, context=context):
            res[sale.id] = True
            for invoice in sale.invoice_ids:
                if invoice.state != 'paid':
                    res[sale.id] = False
                    break
            if not sale.invoice_ids:
                res[sale.id] = False
        return res
    
    _columns = {
        'production_rate': fields.function(_production_rate, method=True, string='Produced', type='float'),
        'produced': fields.function(_produced, method=True, string='Produced',
            type='boolean', help="It indicates that productions are finished", ),#fnct_search=_invoiced_search),
    }
sale_order()
"""
class sale_order(osv.osv):
    _inherit = "sale.order"
    '''
    def action_ship_create(self, cr, uid, ids, *args):
        production_obj = self.pool.get('production.order')
        production_line_obj = self.pool.get('production.order.line')
        
        ret = super(sale_order, self).action_ship_create(cr, uid, ids)
        
        sales = self.browse(cr, uid, ids)
        for sale in sales:
            production_ids = []
            
            for sale_line in sale.order_line:
                production = sale_line.procurement_id and sale_line.procurement_id.production_id or False
                if production:
                    production_ids.append( production.id )
            data = {'ids': production_ids}
            print "sale",sale.id
            print "production_ids",production_ids
        return ret
        '''
sale_order()
"""

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: