# -*- coding: utf-8 -*-
from osv import osv, fields
import netsvc
import time
from tools.translate import _

class wizard_force_cancel(osv.osv_memory):
    _name = 'wizard.force.cancel'
    _description = 'Force at cancel the sale.order and sub-process'
    
    def force_cancel(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        wf_service = netsvc.LocalService("workflow")
        sale_ids = context['active_ids']
        #print "sale_ids",sale_ids
        
        sale_obj = self.pool.get('sale.order')
        sale_line_obj = self.pool.get('sale.order.line')
        picking_obj = self.pool.get('stock.picking')
        production_obj = self.pool.get('mrp.production')
        move_obj = self.pool.get('stock.move')
        workcenter_line_obj = self.pool.get('mrp.production.workcenter.line')
        
        sale_filter = [('sale_id', 'in', sale_ids)]
        
        production_ids = production_obj.search(cr, uid, sale_filter, context=context)
        		
        if not 'sale_id' in cr.query:
            print "No se puede forzar cancelar esta venta, porque no tiene referencias"
            return {}
        #cancel workflow
        #Tambien considerar mrp.production.line
        moves_data = production_obj.read(cr, uid, production_ids, ['move_prod_id', 'picking_id'], context=context)
        move_ids = []
        picking_ids = []
        for move_data in moves_data:
            #print "move_data",move_data
            picking_id = move_data['picking_id'] and move_data['picking_id'][0] or False
            if picking_id:
                picking_ids.append( picking_id )
            move_prod_id = move_data['move_prod_id'] and move_data['move_prod_id'][0] or False
            if move_prod_id:
                move_ids.append( move_prod_id )
            #break
        
        #print "move_ids",move_ids
        #print "move_ids",move_ids
        #print "moves_data",moves_data
        ##production.move_prod_id.picking_id
        pickings_data = move_ids and move_obj.read(cr, uid, move_ids, ['picking_id'], context=context) or []
        for picking_data in pickings_data:
            picking_ids.append( picking_data['picking_id'][0] )
        #sale_filter = ['|', ('sale_id', 'in', sale_ids), ('production_id', 'in', production_ids)]
        picking_ids.extend( picking_obj.search(cr, uid, sale_filter, context=context) )
        
        #print "picking_obj.search--cr.query",cr.query
        #print "picking_ids",picking_ids
        for picking_id in picking_ids:
            wf_service.trg_validate(uid, 'stock.picking', picking_id, 'button_cancel', cr)
        #print "picking_ids",picking_ids
        #############picking_obj.write(cr, uid, picking_ids, {'state': 'cancel'}, context=context)
        
        move_ids.extend( move_obj.search(cr, uid, [('picking_id', 'in', picking_ids)], context=context) )
        #print "move_obj.search--cr.query",cr.query
        #print "move_ids",move_ids
        for move_id in move_ids:
            wf_service.trg_validate(uid, 'stock.move', move_id, 'button_cancel', cr)
        
        workcenter_line_ids = workcenter_line_obj.search(cr, uid, [('production_id', 'in', production_ids)], context=context)
        #print "workcenter_line_obj.search-cr.query",cr.query
        #print "workcenter_line_ids",workcenter_line_ids
        for workcenter_line_id in workcenter_line_ids:
            wf_service.trg_validate(uid, 'mrp.production.workcenter.line', workcenter_line_id , 'button_cancel', cr)
        #########workcenter_line_obj.write(cr, uid, workcenter_line_ids, {'state': 'cancel'}, context=context)
        
        #print "production_obj.search--cr.query",cr.query
        #print "production_ids",production_ids
        for production_id in production_ids:
            wf_service.trg_validate(uid, 'mrp.production', production_id , 'button_cancel', cr)
            
        ########production_obj.write(cr, uid, production_ids, {'state': 'cancel'}, context=context)
        #sale_line_ids = sale_line_obj.search(cr, uid, [('order_id', 'in', sale_ids)], context=context)
        
        for sale_id in sale_ids:
            #wf_service.trg_validate(uid, 'sale.order', sale_id, 'button_cancel', cr)
            #print "action_cancel"
            #wf_service.trg_validate(uid, 'sale.order', sale_id, 'action_cancel', cr)
            #print "cancel"
            #wf_service.trg_validate(uid, 'sale.order', sale_id, 'cancel', cr)
            #print "ship_cancel"
            wf_service.trg_validate(uid, 'sale.order', sale_id, 'ship_cancel', cr)
            wf_service.trg_validate(uid, 'sale.order', sale_id, 'action_cancel', cr)
            wf_service.trg_validate(uid, 'sale.order', sale_id, 'cancel', cr)
            wf_service.trg_validate(uid, 'sale.order', sale_id, 'invoice_cancel', cr)
        
        #Tambien considerar mrp.procurement
        #tambien considerar facturas
        return {}
wizard_force_cancel()
"""
class wizard_finished_wcl(osv.osv_memory):
    _name = 'wizard.finished.wcl'
    _description = 'Finish a Work Center Line with a sequence'

    _columns = {
        'production_id': fields.many2one('mrp.production', 'Produccion', required=True),
        'workcenter_line_id': fields.many2one('mrp.production.workcenter.line', 'Fraccion', required=True),
        #'workcenter_id': fields.many2one('mrp.workcenter', 'Departamento', required=False),
        #'sequence': fields.integer('Fraccion', required=False),
    }
    
    def confirm(self, cr, uid, ids, context={}):
        if not context:
            context = {}
        wkl_obj = self.pool.get('mrp.production.workcenter.line')
        wf_service = netsvc.LocalService("workflow")
        data = self.read(cr, uid, ids)[0]
        workcenter_line_id = data['workcenter_line_id']
        wf_service.trg_validate(uid, 'mrp.production.workcenter.line', workcenter_line_id, 'button_start_working', cr)
        wf_service.trg_validate(uid, 'mrp.production.workcenter.line', workcenter_line_id, 'button_done', cr)
        state = wkl_obj.read(cr, uid, [workcenter_line_id], ['state'], context=context)[0]['state']
        if state <> 'done':
            raise osv.except_osv(_('UserError'), _('No se pudo finalizar esta fraccion\nSe quedo en estado [%s]'%(state)))
        return {}
    
    def onchange_production_id(self, cr, uid, ids, production_id, context={}):
        production_obj = self.pool.get('mrp.production')
        wkl_obj = self.pool.get('mrp.production.workcenter.line')
        res = {}
        wkl_ids = wkl_obj.search(cr, uid, [
            ('production_id', '=', production_id),
            ('state', '<>', 'done'),
            ('name','ilike','%pase%'),
        ], limit=1, order='production_id, sequence', context=context)
        wkl_id = wkl_ids and wkl_ids[0] or False
        res['value'] = {'workcenter_line_id': wkl_id}
        return res
wizard_finished_wcl()
"""
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
